import { isFragment } from './fragment';
import { parseParameter } from './parameter';
export var renderObject = function (nodes, space) {
    var tpl = " {";
    Object.keys(nodes).forEach(function (key) {
        var node = nodes[key];
        if (node === '') {
            tpl += "\n" + renderSpace(space + 2) + key;
            return;
        }
        if (isFragment(key)) {
            tpl += "\n" + renderSpace(space + 2) + node;
            return;
        }
        tpl += "\n" + renderSpace(space + 2) + key + node;
    });
    tpl += "\n" + renderSpace(space) + "}";
    return tpl;
};
export var renderDirectives = function (includeParam, skipParam) {
    var include = includeParam ? " @include(if: $" + parseParameter(includeParam).variable + ")" : '';
    var skip = skipParam ? " @skip(if: $" + parseParameter(skipParam).variable + ")" : '';
    return include + skip;
};
var spaces = [
    '',
    '  ',
    '    ',
    '      ',
    '        ',
    '          ',
    '            ',
    '              ',
    '                ',
    '                  ',
];
export var renderSpace = function (length) {
    return spaces[length / 2] || '';
};
