"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectParams = exports.parseParameter = void 0;
var parseParameter = function (value) {
    var match = value.match(/^([a-z0-9_]+)(?:\sas\s([a-z0-9_]+))?\s*:\s?(.+)$/i);
    if (!match) {
        throw new Error("Parmeter " + value + " is invalid, try to define it like: \"a: Int\", \"b: String\", \"c as myAlias: Int\" and so on.");
    }
    var itemName = match[1];
    var alias = match[2];
    return {
        name: itemName,
        variable: alias || itemName,
        type: match[3],
    };
};
exports.parseParameter = parseParameter;
var collectParams = function (params, ctx) {
    params && params.forEach(function (param) {
        param && (~ctx.params.indexOf(param) || ctx.params.push(param));
    });
};
exports.collectParams = collectParams;
