import { TemplateObj, Parse, VarParams } from './types';
export declare type Space = '' | ' ';
export declare type Suffix = '!' | '';
declare type AliasName<T> = T extends `${string} as ${infer R}` ? TrimRight<R> : TrimRight<T>;
declare type TrimRight<T> = T extends `${infer R} ` ? TrimRight<R> : T;
declare type Variable<T, P = VarParams<T>> = {
    [K in P as K extends `${infer R}:${Space}${'Int' | 'Float'}${Suffix}` ? AliasName<R> : never]: number;
} & {
    [K in P as K extends `${infer R}:${Space}[${'Int' | 'Float'}${Suffix}]${Suffix}` ? AliasName<R> : never]: number[];
} & {
    [K in P as K extends `${infer R}:${Space}${'String' | 'ID'}${Suffix}` ? AliasName<R> : never]: string;
} & {
    [K in P as K extends `${infer R}:${Space}[${'String' | 'ID'}${Suffix}]${Suffix}` ? AliasName<R> : never]: string[];
} & {
    [K in P as K extends `${infer R}:${Space}Boolean${Suffix}` ? AliasName<R> : never]: boolean;
} & {
    [K in P as K extends `${infer R}:${Space}[Boolean]${Suffix}` ? AliasName<R> : never]: boolean[];
} & {
    [K in P as K extends `${string}:${Space}${'Int' | 'Float' | 'String' | 'Boolean' | 'ID'}${Suffix}` ? never : K extends `${string}[${string}]${Suffix}` ? never : K extends `${infer R}:${string}` ? AliasName<R> : never]: Record<string, any> | number | string | boolean;
} & {
    [K in P as K extends `${string}:${Space}[${'Int' | 'Float' | 'String' | 'Boolean' | 'ID'}${Suffix}]${Suffix}` ? never : K extends `${infer R}:${Space}[${string}]${Suffix}` ? AliasName<R> : never]: (Record<string, any> | number | string | boolean)[];
};
export declare type QueryReturn<T> = {
    (variables: Variable<T>): {
        query: string;
        variables: object;
    };
    type: Parse<T>;
    toString(): string;
};
export declare const createContext: (type: string) => typeof query;
export declare function query<T extends TemplateObj<K, V>, K extends any, V extends any>(template: T, options?: {
    name?: string;
}): QueryReturn<T>;
export {};
