"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderSpace = exports.renderDirectives = exports.renderObject = void 0;
var fragment_1 = require("./fragment");
var parameter_1 = require("./parameter");
var renderObject = function (nodes, space) {
    var tpl = " {";
    Object.keys(nodes).forEach(function (key) {
        var node = nodes[key];
        if (node === '') {
            tpl += "\n" + exports.renderSpace(space + 2) + key;
            return;
        }
        if (fragment_1.isFragment(key)) {
            tpl += "\n" + exports.renderSpace(space + 2) + node;
            return;
        }
        tpl += "\n" + exports.renderSpace(space + 2) + key + node;
    });
    tpl += "\n" + exports.renderSpace(space) + "}";
    return tpl;
};
exports.renderObject = renderObject;
var renderDirectives = function (includeParam, skipParam) {
    var include = includeParam ? " @include(if: $" + parameter_1.parseParameter(includeParam).variable + ")" : '';
    var skip = skipParam ? " @skip(if: $" + parameter_1.parseParameter(skipParam).variable + ")" : '';
    return include + skip;
};
exports.renderDirectives = renderDirectives;
var spaces = [
    '',
    '  ',
    '    ',
    '      ',
    '        ',
    '          ',
    '            ',
    '              ',
    '                ',
    '                  ',
];
var renderSpace = function (length) {
    return spaces[length / 2] || '';
};
exports.renderSpace = renderSpace;
